routes/web.php
<?php

Auth::routes();

Route::get('/', 'WelcomeController@welcome');

Route::get('/home', 'HomeController@index')->name('home');

Route::group(['prefix' => 'admin'], function()  {

    Route::resource('users', 'UserController')->middleware('role:HR_Manager');
    Route::resource('roles', 'RoleController')->middleware('role:HR_Manager');
    Route::resource('permissions', 'PermissionController')->middleware('role:HR_Manager');
    Route::resource('nationalities', 'NationalityController')->middleware('role:HR_Manager|HR_Employee');
}); 

Route::get('users/{id}/changeState', 'UserController@changeState')->name('users.changeState')->middleware('role:HR_Manager');

Route::get('nationalities/{id}/changeState', 'NationalityController@changeState')->name('nationalities.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('jobs', 'JobController')->middleware('role:HR_Manager');

Route::get('jobs/{id}/changeState', 'JobController@changeState')->name('jobs.changeState')->middleware('role:HR_Manager');

Route::resource('canceled_jobs', 'CanceledJobController')->middleware('role:HR_Manager');

Route::get('canceled_jobs/{id}/changeState', 'CanceledJobController@changeState')->name('canceled_jobs.changeState')->middleware('role:HR_Manager');

Route::resource('qualifications', 'QualificationController')->middleware('role:HR_Manager|HR_Employee');

Route::get('qualifications/{id}/changeState', 'QualificationController@changeState')->name('qualifications.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('jobs_descriptions', 'JobsDescriptionController')->middleware('role:HR_Manager|HR_Employee');

Route::get('jobs_descriptions/{id}/changeState', 'JobsDescriptionController@changeState')->name('jobs_descriptions.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('classes_contracts', 'ClassesContractController')->middleware('role:HR_Manager|HR_Employee');

Route::get('classes_contracts/{id}/changeState', 'ClassesContractController@changeState')->name('classes_contracts.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('jobs_level', 'JobsLevelController')->middleware('role:HR_Manager|HR_Employee');

Route::get('jobs_level/{id}/changeState', 'JobsLevelController@changeState')->name('jobs_level.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('social_situations', 'SocialSituationController')->middleware('role:HR_Manager|HR_Employee');

Route::get('social_situations/{id}/changeState', 'SocialSituationController@changeState')->name('social_situations.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('employees', 'EmployeeController')->middleware('role:HR_Manager|HR_Employee');

Route::get('employees/{id}/changeState', 'EmployeeController@changeState')->name('employees.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('courses', 'CourseController')->middleware('role:HR_Manager|HR_Employee');

Route::get('courses/{id}/changeState', 'CourseController@changeState')->name('courses.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('employee_courses', 'EmployeesCourseController')->middleware('role:HR_Manager|HR_Employee');

Route::get('employee_courses/{id}/changeState', 'EmployeesCourseController@changeState')->name('employee_courses.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('assignments', 'AssignmentController')->middleware('role:HR_Manager|HR_Employee');

Route::get('employee_trans', 'AssignmentController@employeeTrans')->name('employee_trans')->middleware('role:HR_Manager|HR_Employee');

Route::resource('employees_qualifications', 'EmployeeQualificationController')->middleware('role:HR_Manager|HR_Employee');

Route::get('employees_qualifications/{id}/changeState', 'EmployeeQualificationController@changeState')->name('employees_qualifications.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('employee_cotracts', 'EmployeeCotractController')->middleware('role:HR_Manager|HR_Employee');

Route::get('employee/cotracts/{employee}', 'EmployeeCotractController@new')->name('employee_cotracts.new')->middleware('role:HR_Manager|HR_Employee');

Route::get('employee/cotracts/{employee}/renew', 'EmployeeCotractController@renew')->name('employee_cotracts.renewv')->middleware('role:HR_Manager|HR_Employee');

Route::post('employee/cotracts/{employee}/renew', 'EmployeeCotractController@renewPost')->name('employee_cotracts.renew')->middleware('role:HR_Manager|HR_Employee');

Route::get('employee/cotracts/{id}/decline', 'EmployeeCotractController@decline')->name('employee_cotracts.decline')->middleware('role:HR_Manager|HR_Employee');

Route::get('employee_cotracts/{id}/changeState', 'EmployeeCotractController@changeState')->name('employee_cotracts.changeState')->middleware('role:HR_Manager|HR_Employee');

Route::resource('structures', 'StructureController')->middleware('role:HR_Manager');

Route::get('structures/{id}/changeState', 'StructureController@changeState')->name('structures.changeState')->middleware('role:HR_Manager');

Route::resource('efficiencies', 'EfficiencyController')->middleware('role:HR_Manager|Basic_User');

Route::get('efficiencies/{employee_id}/{year}/show', 'EfficiencyController@show')->name('efficiencies.show')->middleware('role:HR_Manager|Basic_User');

Route::get('efficiencies/{employee_id}/{year}/edit', 'EfficiencyController@edit')->name('efficiencies.edit')->middleware('role:HR_Manager|Basic_User');

Route::resource('overdue', 'OverdueController')->middleware('role:HR_Manager');

Route::get('overdue/{employee}/putin', 'OverdueController@putin')->name('overdue.putin')->middleware('role:HR_Manager');

Route::get('overdue/{employee}/putout', 'OverdueController@putout')->name('overdue.putout')->middleware('role:HR_Manager|HR_Employee');

Route::get('profile', 'ProfileController@show')->name('profile.show');

Route::get('profile/edit', 'ProfileController@edit')->name('profile.edit');

Route::put('profile', 'ProfileController@update')->name('profile.update');

Route::get('jobOpportunities', 'ReportController@jobOpportunities')->name('jobOpportunities')->middleware('role:HR_Manager|HR_Employee');

Route::get('jobNotOpportunities', 'ReportController@jobNotOpportunities')->name('jobNotOpportunities')->middleware('role:HR_Manager|HR_Employee');

Route::get('jobcanceled', 'ReportController@jobcanceled')->name('jobcanceled')->middleware('role:HR_Manager|HR_Employee');

app/Job.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Job extends Model
{
    public function structure()
    {
        return $this->belongsTo('App\Structure');
    }

    public function employee()
    {
        return $this->hasOne(Employee::class);
    }

    public static function onlyAvailable(Employee $employee=null)
    {
        $jobs = static::where(['active'=>true,'taken'=>false,'canceled'=>false])->get();
        
        if(!is_null($employee)){
        if(!is_null($employee->job_id)){
            $jobs->push($employee->job);
        }
    }
         return $jobs;   
    }
    public static function notAvailable()
    {
        return static::where(['active'=>true,'taken'=>true,'canceled'=>false])->get();
    }
    public static function canceled()
    {
        return static::where('canceled',true)->get();
    }
    
}

app/Http/Controllers/JobController.php
<?php

namespace App\Http\Controllers;

use App\Job;
use App\Structure;
use Illuminate\Http\Request;
use App\Rules\AlphaSpacer;
class JobController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $jobs = Job::where('canceled',false)->get();
        return view('jobs.index')->with('jobs', $jobs);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
         $structures = Structure::where('active',true)->get();
        return view ('jobs.create',compact('structures'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $rules = [
            'name' => 'required|regex:/^[\pL\s\-]+$/u|max:50',
            'structure_id' => 'min:0|required|integer|exists:structures,id'
        ];

        $messages = [
            'name.required' => 'حقل اسم الوظيفة إجباري',
            'name.max' => 'يجب أن يكون أقل من 51 خانة',
            'structure_id.min' => 'حقل التبعية مطلوب',
           // 'name.unique' => 'هذه الوظيفة موجودة مسبقاً',
        ];
        
        $this->validate($request, $rules, $messages);

        $job = new Job();
        $job->name = $request->name;
        $job->structure_id = $request->structure_id;
        $job->taken = false;
        $job->save();

        return redirect()->route('jobs.index')->with('success','تم  إضافة الوظيفة بنجاح');

    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Job  $job
     * @return \Illuminate\Http\Response
     */
    public function show(Job $job)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Job  $job
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $job = Job::find($id);
        $structures = Structure::where('active',true)->get();

        return view('jobs.edit',compact('job','structures'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Job  $job
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $rules = [
            'name' => 'required|max:50|regex:/^[\pL\s\-]+$/u',
        ];

        $messages = [
            'name.required' => 'حقل اسم الوظيفة إجباري',
            'name.max' => 'يجب أن يكون أقل من 51 خانة',
          //  'name.unique' => 'هذه الوظيفة موجودة مسبقاً',
        ];
        
        $this->validate($request, $rules, $messages);

        $job = Job::findOrFail($id);
        $job->name = $request->name;
        $job->structure_id = $request->structure_id;
        $job->update();

        return redirect()->route('jobs.index')->with('success','تم  تعديل بيانات الوظيفة بنجاح');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Job  $job
     * @return \Illuminate\Http\Response
     */
    public function destroy(Job $job)
    {
        //
    }

    public function changeState($id)
    {
        $job = Job::findOrFail($id);
        $job->active = !$job->active;
        $job->update();
        
        $msg = '';
        if ($job->active == 1) {
            $msg = 'تم  تفعيل الوظيفة بنجاح';
        } else {
            $msg = 'تم  تعطيل الوظيفة  بنجاح';
        }
        return redirect()->route('jobs.index')->with('success', $msg);
    }


}

resources/views/jobs/create.blade.php
@extends('layouts.main')

@section('page-title')
    الوظائف
@endsection

@section('content')
    <div class="card">
        <div class="card-body">
            <h4 class="header-title">إضافة وظيفة</h4>
            <form action="{{route('jobs.store')}}" method="POST">
                @csrf
<div class="row">
                <div class="col col-md-4">
                    <div class="form-group focused">
                        <label>اسم الوظيفة</label>
                        <input type="text" class="form-control input-sm" name="name" placeholder="اسم الوظيفة">
                    </div>
                </div>
                
                
                <div class="col col-md-4">
                    <div class="form-group focused">
                        <label class="form-control-label">تبعية الهيكل الوظيفي</label>
                        <select class="form-control" name="structure_id">
                            <option value="-1">تبعية الهيكل الوظيفي</option>
                            @foreach ($structures as $structure)
                                <option value="{{ $structure->id }}" >{{ $structure->name }}</option>
                            @endforeach
                        </select>
                    </div>
                </div>
</div>
                <div class="form-group">
                    <button type="submit" class="btn btn-success btn-rounded btn-fw custome-font">إضافة الوظيفة</button>
                    <a href="{{route('jobs.index')}}" class="btn btn-light btn-rounded btn-fw custome-font">إلغاء الأمر</a>
                </div>
            </form>
        </div>
    </div>
@endsection

resources/views/jobs/edit.blade.php
@extends('layouts.main')

@section('title')
    الوظائف
@endsection

@section('content')

        <div class="card">
            <div class="card-body">
                <h4 class="header-title">تعديل وظيفة</h4>
                <form action="{{route('jobs.update', $job->id)}}" method="POST">
                    @csrf
                    @method('PUT')
                    <div class="col col-md-4">
                        <div class="form-group focused">
                        <label>اسم الوظيفة</label>
                        <input type="text" class="form-control input-sm" value="{{$job->name}}" name="name" placeholder="اسم الوظيفة">
                   </div>
                        </div>


                    <div class="col col-md-4">
                        <div class="form-group focused">
                            <label class="form-control-label">تبعية الهيكل الوظيفي</label>
                            <select class="form-control" name="structure_id">
                                <option value="-1">تبعية الهيكل الوظيفي</option>
                                @foreach ($structures as $structure)
                                    <option value="{{ $structure->id }}" {{$structure->id == $job->structure_id ? 'selected':'' }} >{{ $structure->name }}</option>
                                @endforeach
                            </select>                                
                        </div>
                    </div>


                    <div class="form-group">
                        <button type="submit" class="btn btn-success btn-rounded btn-fw custome-font">تعديل الوظيفة</button>
                        <a href="{{route('jobs.index')}}" class="btn btn-light btn-rounded btn-fw custome-font">إلغاء الأمر</a>
                    </div>
                </form>
            </div>
        </div>
@endsection

resources/views/jobs/index.blade.php
@extends('layouts.main')

@section('title')
    الوظائف
@endsection

@section('page-title')
    الوظائف
@endsection
@section('styles')
<link rel="stylesheet" href="https://cdn.datatables.net/1.10.19/css/jquery.dataTables.min.css">
<style>
    .dataTables_length,
    .dataTables_paginate,
    .dataTables_info {
        display: none;
    }
</style>
@endsection
@section('content')
    <div class="card">
        <div class="card-body">
            <h4 class="header-title">قائمة الوظائف</h4>
            <div class="clearfix">
                <a href="{{route('jobs.create')}}" class="btn btn-success btn-rounded btn-fw clearfix">إضافة وظيفة </a>
            </div>
            <br>
            <div class="single-table">
                <div class="table-responsive">
                    <table class="table "id="myTable">
                        <thead class="text-uppercase bg-light">
                            <tr>
                                <th>#رقم</th>
                                <th>اسم الوظيفة</th>
                                <th>الحالة </th>
                                <th>التحكم</th>
                            </tr>
                        </thead>
                        <tbody>
                        @foreach ($jobs as $index=>$job)
                            <tr>
                                <td>{{$index + 1}}</td>
                                <td>{{$job->name}}</td>
                                <td>
                                    @if ($job->active == 1)
                                        <div class="badge badge-success">مفعل</div>
                                    @else
                                        <div class="badge badge-danger">معطل</div>
                                    @endif
                                </td>

                                <td>
                                    <a href="{{route('jobs.edit', $job->id)}}" class="btn btn-icons btn-rounded btn-primary btn-sm" data-toggle="tooltip" title="تعديل"><i class="mdi mdi-pen"></i></a>
                                    
                                    {{-- <a class="btn btn-icons btn-rounded btn-danger remove-record" data-csrf="{{csrf_token()}}" data-toggle="modal" data-url="{{route('jobs.destroy', $job->id) }}" data-id="{{$job->id}}" data-target="#custom-width-modal"><i class="mdi mdi-delete"></i></a> --}}
                                    
                                    @if ($job->active == 1)
                                        <a href="{{route('jobs.changeState', $job->id)}}" class="btn btn-icons btn-rounded btn-danger btn-sm" data-toggle="tooltip" title="تعطيل"><i class="mdi mdi-close-circle-outline"></i></a>
                                    @else
                                        <a href="{{route('jobs.changeState', $job->id)}}" class="btn btn-icons btn-rounded btn-success btn-sm" data-toggle="tooltip" title="تفعيل"><i class="mdi mdi-checkbox-marked-circle"></i></a>
                                    @endif
                                </td>
                            </tr>
                        @endforeach

                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>

@endsection

@section('modals')
    @include('includes.delete-confirmation')
@endsection



@section('scripts') {{--
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script> --}}
<script src="{{ asset('js/delete-confremation.js') }}"></script>
<script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"></script>
<script>
    $(document).ready( function () { $('#myTable').DataTable(); } );
            $('#myTable').dataTable( { "language": { "search": "بحث:" } } );
</script>
@endsection